##############################################################################
# Module : interconn.py
# Author :
# Date   :
# Updated and modified for ABC_OKC : Old King Cole
#
# Description : Communication between ABC_OKC and ABC_OKC starter
#
##############################################################################
import wx, sys, socket


###################################################################################################
# ServerListener Class :
#    Single instance opens local port for taking parameter from starter
###################################################################################################
class ServerListener:
    def __init__(self):
        self.s = None

    def start(self, parent):
        self.parent = parent
        for res in socket.getaddrinfo('127.0.0.1', self.parent.utility.mainport, socket.AF_UNSPEC, socket.SOCK_STREAM, 0, socket.AI_PASSIVE):
            af, socktype, proto, canonname, sa = res
            try:
                self.s = socket.socket(af, socktype, proto)
            except socket.error, msg:
                self.s = None
                continue
            try:
                self.s.bind(sa)
                self.s.listen(1)
            except socket.error, msg:
                self.s.close()
                self.s = None
                continue
            break
        if self.s is None:
            print 'could not open socket'
            sys.exit(1)
        while True:
            try:
                conn, addr = self.s.accept()
                data = conn.recv(1024)
                conn.close()
                if data == "Please close connection!!":
                    self.s.close()
                    self.s = None
                    break
                else:
                    try:
                        params = data.decode('utf-8').split("|")
                    except:
                        continue
                    if not '-m' in params and not '-a' in params and not '-c' in params:
                        # No parameters or only -p parameter
                        self.parent.parent.onTaskBarActivate()
                    else:
                        self.parent.queue.invokeLater(self.parent.commandLineMode, [params])
                        self.parent.queue.invokeLater(self.parent.commandLineAddTorrent, [params])
                        self.parent.queue.invokeLater(self.parent.commandLineCommand, [params])

            except wx.PyDeadObjectError:
                sys.stderr.write("\nPlease wait until ABC finishes shutting down and retry\n")
                break


###################################################################################################
# clientPassParam :
#    ABC_OKC starter passes parameter to ABC_OKC single instance and closes immediately
###################################################################################################
def clientPassParam(params, port = None):
    if port is None:
        try:
            port = int(params[params.index('-p') + 1])
        except:
            port = 56666
        else:
            if port < 0 or port > 65535:
                port = 56666
    s = None
    for res in socket.getaddrinfo('127.0.0.1', port, socket.AF_UNSPEC, socket.SOCK_STREAM):
        af, socktype, proto, canonname, sa = res
        try:
            s = socket.socket(af, socktype, proto)
        except socket.error, msg:
            s = None
            continue
        try:
            s.connect(sa)
        except socket.error, msg:
            s.close()
            s = None
            continue
        break
    if s is None:
        print 'could not open socket'
        sys.exit(1)

    s.send('|'.join(params).encode('utf-8'))
    s.close()
